<template lang="pug">
	a.movie-block(:class="colorClass", :href="movie.url")
		div.movie-title-wrapper.column: div
			span.movie-title {{ movie.title }}
			span.movie-year(v-if="haveMovieYear")  ({{ movie.year }})
		div.movie-score.column: span(v-if="haveMovieScore") {{ movie.score }}
</template>

<script>
	import { Movie } from '~/classes/Movie';

	const FRESH_SCORE = 60;

	export default {
		name: 'MovieBlock',
		props: {
			movie: {
				type: Object,
				required: true,
				validator: movie => movie instanceof Movie
			}
		},
		data () {
			const haveMovieScore = typeof this.movie.score === 'number';
			const haveMovieYear = typeof this.movie.year === 'number';

			let colorClass = '';

			if (haveMovieScore && this.movie.score >= FRESH_SCORE) colorClass = 'red';
			else if (haveMovieScore) colorClass = 'green';

			return { colorClass, haveMovieScore, haveMovieYear };
		}
	};
</script>

<style lang="scss" scoped>
	@import "~/scss/variables";

	a.movie-block {
		// Animation
		transition: all 0.3s cubic-bezier(0.25, 0.8, 0.25, 1);
		will-change: box-shadow;

		// Color and Typography
		background-color: $base01;
		color: $base05;
		line-height: 1.6em;

		// Layout
		display: flex;
		justify-content: space-between;
		align-items: stretch;

		// Size
		margin-bottom: 1rem;
		padding: 1rem;
		min-height: 5rem;
		box-shadow: 0 0.125rem 0.375rem rgba(0, 0, 0, 0.12), 0 0.125rem 0.25rem rgba(0, 0, 0, 0.24);
		border-radius: 0.25rem;

		// Media Queries
		@media screen and (min-width: $desktop-width) {
			padding: 0.5rem 1rem;
			min-height: 3rem;
		}

		// Derivative Styles
		&:hover {
			text-decoration: none;
			box-shadow: 0 0.375rem 0.75rem rgba(0, 0, 0, 0.16), 0 0.375rem 0.75rem rgba(0, 0, 0, 0.23);
		}

		&.green,
		&.red,
		&.yellow { color: $base00; }

		&.yellow { background-color: $yellow; }

		&.green { background-color: $green; }

		&.red { background-color: $red; }

		div.column {
			display: flex;
			flex-direction: column;
			justify-content: center;

			&.movie-title-wrapper {
				font-size: 1.5rem;
				text-align: left;
				font-weight: 600;

				@media screen and (min-width: $desktop-width) { font-size: 1.125rem; }
			}

			&.movie-score {
				font-size: 3rem;
				font-weight: 700;
				margin-left: 3rem;

				@media screen and (min-width: $desktop-width) { font-size: 1.75rem; }
			}
		}
	}
</style>
